Index: branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Views/Job/Index.cshtml
===================================================================
--- branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Views/Job/Index.cshtml	(revision 13754)
+++ branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Views/Job/Index.cshtml	(revision 13827)
@@ -1,8 +1,13 @@
 ﻿@using HeuristicLab.Clients.Hive.WebJobManager.ViewModels
 @model JobViewModel
+
+<!-- Displays the job manager overview -->
+
 <div id="userId" style="display:none">@ViewBag.SessionId</div>
 <div>
+    <!-- Main nav menu-->
     @Html.Partial("Navbar", new NavbarViewModel("Job"))
 
+    <!-- Job menu-->
     <ul class="nav nav-pills nav-justified">
         <li role="presentation"
@@ -38,5 +43,6 @@
 
         }
-        else {
+        else
+        {<!-- Display side menu containing jobs. -->
             <div class="col-sm-4">
                 <div class="btn-group-vertical btn-block">
@@ -78,5 +84,5 @@
                  style="padding:5px; padding-left:10px;">
                 @if (Model.selectedJob != null)
-                {
+                { <!-- A job has been selected by the user, load info into view -->
                     <div class="panel panel-default"
                          style="border-width:2px!important;padding:17px;
@@ -84,4 +90,5 @@
                         <div class="row">
                             <h2 style="padding-left:20px">
+                                <!-- Header of the job (title and delete button) -->
                                 @Model.selectedJob.Job.Name
                                 <a onclick="popUpDelete()"
@@ -93,5 +100,6 @@
                                     Delete job
                                 </a>
-                                <a style="display:none; "
+                                <!-- HIDDEN BUTTON FOR ASP ACTION -->
+                                <a style="display:none; " 
                                    asp-action="Delete"
                                    asp-route-id="@Model.selectedJob.Id"
@@ -100,5 +108,5 @@
 
                                 <script type="text/javascript">
-                                    function popUpDelete() {
+                                    function popUpDelete() {//Quick inline popup with hidden asp button
                                         if (confirm("Are you sure you want to delete this job?") == true) {
                                             document.getElementById("del").click();
@@ -110,4 +118,5 @@
                             </h2>
                             <div class="col-sm-6" style="padding-left:30px">
+                                <!-- Information of the job -->
                                 <p>Description: @Model.selectedJob.Job.Description</p>
                                 <p>Resources: @Model.selectedJob.Job.ResourceNames</p>
@@ -138,4 +147,5 @@
                         <div class="row" style="text-align:center">
                             @Html.Partial("_Graphlegend")
+                            <!-- Main graph giving overview of all the jobs-->
                             <div id="graphMain" style="width:100%;height:0px">
 
@@ -151,5 +161,5 @@
                             </h3>
                             @foreach (var task in Model.selectedJob.HiveTasks)
-                            {
+                            {<!--Display all child jobs recursively -->
                                 @Html.Partial("SelectedJobPartials/_TaskPartial",
                            new HeuristicLab.Clients.Hive.WebJobManager.Models.HiveTaskContainer(task))
@@ -164,10 +174,10 @@
         }
         <script type="text/javascript">
-            function showLoader() {
+            function showLoader() {//Shows load spinner
                 document.getElementById("content").style.display = "none";
                 document.getElementById("loader").style.display = "";
 
             }
-            function showDeleter() {
+            function showDeleter() {//Shows delete spinner
                 document.getElementById("content").style.display = "none";
                 document.getElementById("loader").style.display = "";