Index: branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Views/Job/OpenFilePartials/DataPartials/BoolArray.cshtml
===================================================================
--- branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Views/Job/OpenFilePartials/DataPartials/BoolArray.cshtml	(revision 13841)
+++ branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Views/Job/OpenFilePartials/DataPartials/BoolArray.cshtml	(revision 13841)
@@ -0,0 +1,21 @@
+﻿@model HeuristicLab.Clients.Hive.WebJobManager.ViewModels.Jobs.DataPackageVM
+@using HeuristicLab.Data;
+@using HeuristicLab.Core;
+
+<td>
+    @{
+        var dat = (BoolArray)Model.Data.ActualValue;
+        var s = "";
+        foreach (var d in dat)
+        {
+            s += d + "; ";
+
+        }
+    }
+    <textarea style="width:100%; resize:vertical"
+              value="@Model.Data"
+              onchange="paraEdit(@Model.Position,'@Model.Problem.ToString()',
+           '@Model.Data.Name', '@Model.Data.DataType.ToString()',this.value)">
+        @s
+    </textarea>
+</td>
Index: branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Views/Job/OpenFilePartials/DataPartials/BoolMatrix.cshtml
===================================================================
--- branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Views/Job/OpenFilePartials/DataPartials/BoolMatrix.cshtml	(revision 13841)
+++ branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Views/Job/OpenFilePartials/DataPartials/BoolMatrix.cshtml	(revision 13841)
@@ -0,0 +1,30 @@
+﻿@model HeuristicLab.Clients.Hive.WebJobManager.ViewModels.Jobs.DataPackageVM
+@using HeuristicLab.Data;
+@using HeuristicLab.Core;
+
+<td>
+    @{
+        var dat = (BoolMatrix)Model.Data.ActualValue;
+        var s = "";
+        for (var d = 0; d < dat.Rows;d++)
+        {
+            s += "[ ";
+            for(var i = 0; i < dat.Columns; i++)
+            {
+                s += dat[d, i] ;
+                if(i < dat.Columns - 1) {
+                    s += "; ";
+                }
+
+            }
+            s += " ] " + Environment.NewLine;
+
+        }
+    }
+    <textarea style="width:100%; resize:vertical"
+              value="@Model.Data"
+              onchange="paraEdit(@Model.Position,'@Model.Problem.ToString()',
+           '@Model.Data.Name', '@Model.Data.DataType.ToString()',this.value)">
+        @s
+    </textarea>
+</td>
Index: branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Views/Job/OpenFilePartials/DataPartials/DataMaster.cshtml
===================================================================
--- branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Views/Job/OpenFilePartials/DataPartials/DataMaster.cshtml	(revision 13834)
+++ branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Views/Job/OpenFilePartials/DataPartials/DataMaster.cshtml	(revision 13841)
@@ -12,7 +12,23 @@
                 @Html.Partial("OpenFilePartials/DataPartials/Bool", Model);
             }
+            else if (Model.Data.ActualValue is BoolArray)
+            {
+                @Html.Partial("OpenFilePartials/DataPartials/BoolArray", Model);
+            }
+            else if (Model.Data.ActualValue is BoolMatrix)
+            {
+                @Html.Partial("OpenFilePartials/DataPartials/BoolMatrix", Model);
+            }
             else if (Model.Data.ActualValue is StringValue)
             {
                 @Html.Partial("OpenFilePartials/DataPartials/String", Model);
+            }
+            else if (Model.Data.ActualValue is StringArray)
+            {
+                @Html.Partial("OpenFilePartials/DataPartials/StringArray", Model);
+            }
+            else if (Model.Data.ActualValue is StringMatrix)
+            {
+                @Html.Partial("OpenFilePartials/DataPartials/StringMatrix", Model);
             }
             else if (Model.Data.ActualValue is IntValue)
@@ -20,15 +36,27 @@
                 @Html.Partial("OpenFilePartials/DataPartials/Int", Model);
             }
+            else if (Model.Data.ActualValue is IntArray && !(Model.Data.ActualValue is HeuristicLab.Encodings.PermutationEncoding.Permutation))
+            {
+                @Html.Partial("OpenFilePartials/DataPartials/IntArray", Model);
+            }
+            else if (Model.Data.ActualValue is IntMatrix)
+            {
+                @Html.Partial("OpenFilePartials/DataPartials/IntMatrix", Model);
+            }
             else if (Model.Data.ActualValue is PercentValue)
             {
                 @Html.Partial("OpenFilePartials/DataPartials/Percent", Model);
             }
+            else if (Model.Data.ActualValue is PercentArray)
+            {
+                @Html.Partial("OpenFilePartials/DataPartials/PercentArray", Model);
+            }
+            else if (Model.Data.ActualValue is PercentMatrix)
+            {
+                @Html.Partial("OpenFilePartials/DataPartials/PercentMatrix", Model);
+            }
             else if (Model.Data.ActualValue is DoubleValue)
             {
                 @Html.Partial("OpenFilePartials/DataPartials/Double", Model);
-            }
-            else if (Model.Data.ActualValue is IntArray)
-            {
-                @Html.Partial("OpenFilePartials/DataPartials/IntArray", Model);
             }
             else if (Model.Data.ActualValue is DoubleArray)
@@ -42,10 +70,10 @@
             else if (Model.Data.ActualValue is IItem)
             {
-                @Html.Partial("OpenFilePartials/DataPartials/Others", Model);
+                @Html.Partial("OpenFilePartials/DataPartials/OthersClean", Model);//just Others to print the datatype too 
                 }
         }
         catch(NotSupportedException e)
         {
-            @Html.Partial("OpenFilePartials/DataPartials/Others", Model)
+            @Html.Partial("OpenFilePartials/DataPartials/OthersClean", Model)
 
         }
Index: branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Views/Job/OpenFilePartials/DataPartials/DoubleMatrix.cshtml
===================================================================
--- branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Views/Job/OpenFilePartials/DataPartials/DoubleMatrix.cshtml	(revision 13834)
+++ branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Views/Job/OpenFilePartials/DataPartials/DoubleMatrix.cshtml	(revision 13841)
@@ -10,5 +10,13 @@
         {
             s += "[ ";
-            s += dat[d,0] + "; " + dat[d,1];
+            for (var i = 0; i < dat.Columns; i++)
+            {
+                s += dat[d, i];
+                if (i < dat.Columns - 1)
+                {
+                    s += "; ";
+                }
+
+            }
             s += " ] " + Environment.NewLine;
 
Index: branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Views/Job/OpenFilePartials/DataPartials/IntMatrix.cshtml
===================================================================
--- branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Views/Job/OpenFilePartials/DataPartials/IntMatrix.cshtml	(revision 13841)
+++ branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Views/Job/OpenFilePartials/DataPartials/IntMatrix.cshtml	(revision 13841)
@@ -0,0 +1,31 @@
+﻿@model HeuristicLab.Clients.Hive.WebJobManager.ViewModels.Jobs.DataPackageVM
+@using HeuristicLab.Data;
+@using HeuristicLab.Core;
+
+<td>
+    @{
+        var dat = (IntMatrix)Model.Data.ActualValue;
+        var s = "";
+        for (var d = 0; d < dat.Rows; d++)
+        {
+            s += "[ ";
+            for (var i = 0; i < dat.Columns; i++)
+            {
+                s += dat[d, i];
+                if (i < dat.Columns - 1)
+                {
+                    s += "; ";
+                }
+
+            }
+            s += " ] " + Environment.NewLine;
+
+        }
+    }
+    <textarea style="width:100%; resize:vertical"
+              value="@Model.Data"
+              onchange="paraEdit(@Model.Position,'@Model.Problem.ToString()',
+           '@Model.Data.Name', '@Model.Data.DataType.ToString()',this.value)">
+        @s
+    </textarea>
+</td>
Index: branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Views/Job/OpenFilePartials/DataPartials/OthersClean.cshtml
===================================================================
--- branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Views/Job/OpenFilePartials/DataPartials/OthersClean.cshtml	(revision 13841)
+++ branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Views/Job/OpenFilePartials/DataPartials/OthersClean.cshtml	(revision 13841)
@@ -0,0 +1,7 @@
+﻿@model HeuristicLab.Clients.Hive.WebJobManager.ViewModels.Jobs.DataPackageVM
+@using HeuristicLab.Data;
+@using HeuristicLab.Core;
+
+<td>
+    @Model.Data.ActualValue
+</td>
Index: branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Views/Job/OpenFilePartials/DataPartials/PercentArray.cshtml
===================================================================
--- branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Views/Job/OpenFilePartials/DataPartials/PercentArray.cshtml	(revision 13841)
+++ branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Views/Job/OpenFilePartials/DataPartials/PercentArray.cshtml	(revision 13841)
@@ -0,0 +1,21 @@
+﻿@model HeuristicLab.Clients.Hive.WebJobManager.ViewModels.Jobs.DataPackageVM
+@using HeuristicLab.Data;
+@using HeuristicLab.Core;
+
+<td>
+    @{
+        var dat = (PercentArray)Model.Data.ActualValue;
+        var s = "";
+        foreach (var d in dat)
+        {
+            s += d + "; ";
+
+        }
+    }
+    <textarea style="width:100%; resize:vertical"
+              value="@Model.Data"
+              onchange="paraEdit(@Model.Position,'@Model.Problem.ToString()',
+           '@Model.Data.Name', '@Model.Data.DataType.ToString()',this.value)">
+        @s
+    </textarea>
+</td>
Index: branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Views/Job/OpenFilePartials/DataPartials/PercentMatrix.cshtml
===================================================================
--- branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Views/Job/OpenFilePartials/DataPartials/PercentMatrix.cshtml	(revision 13841)
+++ branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Views/Job/OpenFilePartials/DataPartials/PercentMatrix.cshtml	(revision 13841)
@@ -0,0 +1,31 @@
+﻿@model HeuristicLab.Clients.Hive.WebJobManager.ViewModels.Jobs.DataPackageVM
+@using HeuristicLab.Data;
+@using HeuristicLab.Core;
+
+<td>
+    @{
+        var dat = (PercentMatrix)Model.Data.ActualValue;
+        var s = "";
+        for (var d = 0; d < dat.Rows; d++)
+        {
+            s += "[ ";
+            for (var i = 0; i < dat.Columns; i++)
+            {
+                s += dat[d, i];
+                if (i < dat.Columns - 1)
+                {
+                    s += "; ";
+                }
+
+            }
+            s += " ] " + Environment.NewLine;
+
+        }
+    }
+    <textarea style="width:100%; resize:vertical"
+              value="@Model.Data"
+              onchange="paraEdit(@Model.Position,'@Model.Problem.ToString()',
+           '@Model.Data.Name', '@Model.Data.DataType.ToString()',this.value)">
+        @s
+    </textarea>
+</td>
Index: branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Views/Job/OpenFilePartials/DataPartials/StringArray.cshtml
===================================================================
--- branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Views/Job/OpenFilePartials/DataPartials/StringArray.cshtml	(revision 13841)
+++ branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Views/Job/OpenFilePartials/DataPartials/StringArray.cshtml	(revision 13841)
@@ -0,0 +1,21 @@
+﻿@model HeuristicLab.Clients.Hive.WebJobManager.ViewModels.Jobs.DataPackageVM
+@using HeuristicLab.Data;
+@using HeuristicLab.Core;
+
+<td>
+    @{
+        var dat = (StringArray)Model.Data.ActualValue;
+        var s = "";
+        foreach (var d in dat)
+        {
+            s += d + "; ";
+
+        }
+    }
+    <textarea style="width:100%; resize:vertical"
+              value="@Model.Data"
+              onchange="paraEdit(@Model.Position,'@Model.Problem.ToString()',
+           '@Model.Data.Name', '@Model.Data.DataType.ToString()',this.value)">
+        @s
+    </textarea>
+</td>
Index: branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Views/Job/OpenFilePartials/DataPartials/StringMatrix.cshtml
===================================================================
--- branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Views/Job/OpenFilePartials/DataPartials/StringMatrix.cshtml	(revision 13841)
+++ branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Views/Job/OpenFilePartials/DataPartials/StringMatrix.cshtml	(revision 13841)
@@ -0,0 +1,30 @@
+﻿@model HeuristicLab.Clients.Hive.WebJobManager.ViewModels.Jobs.DataPackageVM
+@using HeuristicLab.Data;
+@using HeuristicLab.Core;
+
+<td>
+    @{
+        var dat = (StringMatrix)Model.Data.ActualValue;
+        var s = "";
+        for (var d = 0; d < dat.Rows; d++)
+        {
+            s += "[ ";
+            for (var i = 0; i < dat.Columns; i++)
+            {
+                s += dat[d, i];
+                if (i < dat.Columns - 1)
+                {
+                    s += "; ";
+                }
+
+            }
+            s += " ] " + Environment.NewLine;
+        }
+    }
+    <textarea style="width:100%; resize:vertical"
+              value="@Model.Data"
+              onchange="paraEdit(@Model.Position,'@Model.Problem.ToString()',
+           '@Model.Data.Name', '@Model.Data.DataType.ToString()',this.value)">
+        @s
+    </textarea>
+</td>