Index: /branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Hubs/ProgressHub.cs
===================================================================
--- /branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Hubs/ProgressHub.cs	(revision 13843)
+++ /branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Hubs/ProgressHub.cs	(revision 13844)
@@ -70,9 +70,12 @@
         {
             loader();
+            bool change = false;
+            string name = "";
             HiveTask current = fileopener.Job.HiveTasks.ToList()[0];
             if (arr.Length == 0)
             {//check if upper job
                 current.ItemTask.ComputeInParallel = !current.ItemTask.ComputeInParallel;
-
+                change = current.ItemTask.ComputeInParallel;
+                name = current.ItemTask.Name;
             }
             else
@@ -87,8 +90,12 @@
                         {
                             current.ChildHiveTasks[arr[i][1]].ItemTask.ComputeInParallel = !current.ChildHiveTasks[arr[i][1]].ItemTask.ComputeInParallel;
+                            change = current.ChildHiveTasks[arr[i][1]].ItemTask.ComputeInParallel;
+                            name = current.ChildHiveTasks[arr[i][1]].ItemTask.Name;
                         }
                         else if (current.ItemTask.Item is Experiment)
                         {
                             current.ChildHiveTasks[arr[i][0]].ItemTask.ComputeInParallel = !current.ChildHiveTasks[arr[i][0]].ItemTask.ComputeInParallel;
+                            change = current.ChildHiveTasks[arr[i][0]].ItemTask.ComputeInParallel;
+                            name = current.ChildHiveTasks[arr[i][0]].ItemTask.Name;
                         }
 
@@ -103,5 +110,8 @@
                 }
             }
-            Clients.Caller.processMessage("Connection Established");
+            if (change)
+                Clients.Caller.saveComplete("Child distribution activated for " + name);
+            else
+                Clients.Caller.saveComplete("Child distribution deactivated for " + name);
         }
         public void changeName(int[][] arr, string name, int idname)
@@ -111,8 +121,9 @@
             {
                 loader();
-
+                string old = "";
                 HiveTask current = fileopener.Job.HiveTasks.ToList()[0];
                 if (arr.Length == 0)
                 {//check if upper job
+                    old = current.ItemTask.Name;
                     current.ItemTask.Name = name;
 
@@ -126,8 +137,10 @@
                             if (current.ItemTask.Item is BatchRun)
                             {
+                                old = current.ChildHiveTasks[arr[i][1]].ItemTask.Name;
                                 current.ChildHiveTasks[arr[i][1]].ItemTask.Name = name;
                             }
                             else if (current.ItemTask.Item is Experiment)
                             {
+                                old = current.ChildHiveTasks[arr[i][0]].ItemTask.Name;
                                 current.ChildHiveTasks[arr[i][0]].ItemTask.Name = name;
                             }
@@ -144,4 +157,5 @@
                 }
                 Clients.Caller.processName(name, idname);
+                Clients.Caller.saveComplete( old + " renamed to " + name);
             }
         }
@@ -183,5 +197,8 @@
                 }
             }
-            Clients.Caller.processRepit(Name, repit);
+            if (Name == "failed")
+                Clients.Caller.createAlert("Something went wrong while changing the repititions, please try again", "danger");
+            else
+                Clients.Caller.saveComplete("Repititions changed to "+repit+ " for " + Name);
 
         }
@@ -196,4 +213,5 @@
         public void ChangePriority(int[][] arr, int prior)
         {
+            string name = "";
             loader();
             HiveTask current = fileopener.Job.HiveTasks.ToList()[0];
@@ -201,5 +219,5 @@
             {//check if upper job
                 current.Task.Priority = prior;
-
+                name = current.ItemTask.Name;
             }
             else
@@ -214,8 +232,10 @@
                         {
                             current.ChildHiveTasks[arr[i][1]].Task.Priority = prior;
+                            name = current.ChildHiveTasks[arr[i][0]].ItemTask.Name;
                         }
                         else if (current.ItemTask.Item is Experiment)
                         {
                             current.ChildHiveTasks[arr[i][0]].Task.Priority = prior;
+                            name = current.ChildHiveTasks[arr[i][0]].ItemTask.Name;
                         }
 
@@ -230,4 +250,5 @@
                 }
             }
+            Clients.Caller.saveComplete("Priority changed for " + name);
         }
         /// <summary>
@@ -356,4 +377,5 @@
                             alg.Parameters[name].ActualValue = (IItem)val;
                         }
+                        Clients.Caller.saveComplete("Parameter saved for " + name);
                     }
                     catch (NullReferenceException e)
@@ -367,9 +389,9 @@
                     catch (NotSupportedException e)
                     {
-                        Clients.Caller.dataNotSupported(name);
+                        Clients.Caller.createAlert("Parameter " + name + " could not be changed for it is a fixed parameter. All changes done in this view are not saved to Hive.", "danger");
                     }
                 }
                 else
-                    Clients.Caller.formatWrong(name, type);
+                    Clients.Caller.createAlert("Format wrong for " + name + " of type " + type + ". Make sure you follow the right format pattern.", "warning");
 
 
Index: /branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Scripts/Hubs/ProgressHubber.js
===================================================================
--- /branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Scripts/Hubs/ProgressHubber.js	(revision 13843)
+++ /branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Scripts/Hubs/ProgressHubber.js	(revision 13844)
@@ -2,5 +2,7 @@
 
 $(function () {
-   // $.connection.hub.logging = true;
+    // $.connection.hub.logging = true;
+    $("#success-alert").hide();
+
     var v = document.getElementById("userId").innerHTML;
     console.log(v);
@@ -27,16 +29,19 @@
         
     };
-    hubber.client.processRepit = function (name, repit) {
-        if (name === "failed") {
-            window.alert("Something went wrong while changing the repititions, please try again")
-        }
-        else
-            window.alert("Repititions for " + name + " has been changed to " + repit + ". These changes are not shown in the interface but happen directly after uploading or saving.");
+    
+    hubber.client.saveComplete = function (text) {
+        $("#succText").html(text);
+        $("#success-alert").alert();
+        $("#success-alert").fadeTo(2000, 500).slideUp(500, function () {
+            $("#success-alert").hide();
+        });
     }
-    hubber.client.dataNotSupported = function (name) {
-        window.alert("Parameter " + name + " could not be changed for it is a fixed parameter. All changes done in this view are not saved to Hive.");
+    hubber.client.createAlert = function (text, type) {
+        $("#logs").html(
+           "<div class='alert alert-" + type + " alert-dismissible fade in' role='alert'> <button type='button' class='close' data-dismiss='alert' aria-label='Close'> " +
+   "<span aria-hidden='true'>&times;</span> </button> " + text + "</div>" + $("#logs").html());
     }
     hubber.client.formatWrong = function (name, type) {
-        window.alert("Parameter " + name + " could not be changed, the format for "+type+ " was wrong. Make sure you follow the example exactly. No changes made on Hive");
+        addAlert("Format wrong for " + name + " of type " + type + ". Make sure you follow the right format pattern.", "warning");
     }
 });
Index: /branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Services/Imports/AccessAdministrationClient.cs
===================================================================
--- /branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Services/Imports/AccessAdministrationClient.cs	(revision 13843)
+++ /branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Services/Imports/AccessAdministrationClient.cs	(revision 13844)
@@ -28,4 +28,5 @@
 using HeuristicLab.Clients.Hive.WebJobManager.Services;
 using System.Collections.Generic;
+using System.ServiceModel.Security;
 
 namespace HeuristicLab.Clients.Access.Administration
@@ -58,4 +59,25 @@
             weblog = WebLoginService.Instance;
             userId = u;
+        }
+
+        public bool checkAuthorised()
+        {
+            if (client != null)
+            {
+                try
+                {
+                    client.GetAllUsers();
+                    return true;
+                }
+                catch (Exception e)
+                {
+                    if (e is MessageSecurityException || e is InvalidOperationException)
+                    {
+                        return false;
+                    }
+                    throw;
+                }
+            }
+            return false;
         }
 
Index: /branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Views/Job/OpenFile.cshtml
===================================================================
--- /branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Views/Job/OpenFile.cshtml	(revision 13843)
+++ /branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Views/Job/OpenFile.cshtml	(revision 13844)
@@ -153,5 +153,5 @@
 
                 <!-- Progress-->
-                
+
                 <h4 id="result" style="display:none">Start uploading experiment...</h4>
                 <div class="progress" id="progdiv" style="display:none">
@@ -168,5 +168,5 @@
                 <p style="text-align:center;font-style:italic">Changed parameters get saved but child distribution and task priority get lost in the process.</p>
                 <form asp-controller="Job"
-                   asp-action="saveToFile"
+                      asp-action="saveToFile"
                       method="post">
                     <div class="col-sm-6"
@@ -191,8 +191,9 @@
                         <h5>Directory: /HiveChanged</h5>
                     </div>
-                    <button class="btn btn-success btn-block" type="submit" 
+                    <button class="btn btn-success btn-block" type="submit"
                             style="margin:10px; box-shadow: 0 4px 8px 0 rgba(0, 0, 0, 0.2), 0 6px 20px 0 rgba(0, 0, 0, 0.19);
                             text-shadow:2px 2px black;">
-                    Save to file</button>
+                        Save to file
+                    </button>
                 </form>
             </div>
@@ -202,6 +203,5 @@
     </div>
     <!-- Side scrolling menu-->
-    <nav 
-         class="col-md-2" id="scrolly">
+    <nav class="col-md-2" id="scrolly">
         <ul class="nav nav-pills nav-stacked"
             data-spy="affix"
@@ -219,12 +219,21 @@
                 <li><a onclick="shower()" href="#tasks"><i class="fa fa-eye"></i> Show all tasks</a></li>
                 <li><a onclick="collapser()" href="#tasks"><i class="fa fa-eye-slash"></i> Hide all tasks</a></li>
-                
+
             }
             <li><a href="#finish"><i class="fa fa-flag-checkered"></i> Add to Hive or save to file</a></li>
+            <li>
+                <div class="alert alert-success" id="success-alert">
+                    <span id="succText"></span>
+                </div>
+                <p id="logs">
+                    
+                </p>
+            </li>
         </ul>
+
     </nav>
 
     <script src="~/js/hubs/progresshubber.js"></script>
-    
+
     <script>
         showScrolly = function () {
@@ -246,9 +255,9 @@
             });
             $('body').click(function () {
-                if ($("#ctasks").length > 0) 
+                if ($("#ctasks").length > 0)
                     $("#ctasks").html("<i class='fa fa-sitemap'></i> Tasks (" + $('a[href^="#collapseExample"]').length + ")");
             });
             $('body').click();
-            
+
         });
         collapser = function () {
Index: /branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Views/Job/OpenFilePartials/_BatchRun.cshtml
===================================================================
--- /branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Views/Job/OpenFilePartials/_BatchRun.cshtml	(revision 13843)
+++ /branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Views/Job/OpenFilePartials/_BatchRun.cshtml	(revision 13844)
@@ -26,11 +26,11 @@
     <h4 id="tasks">
         Repeats:
-        <input type="number" 
+        <input type="number"
                class="form-control"
                style="width:80px;display:initial"
-               min="1" 
+               min="1"
                value="@Model.SelectedBatchRun.Repetitions"
                onchange="changeRepit([],this.value,@randy)" />
-          x
+        x
 
     </h4>
@@ -45,13 +45,12 @@
     </p>
     <div id="childs@(randy)">
-        @for (var k = 0; k < Model.SelectedBatchRun.Repetitions; k++)
-        {
-            @if (Model.SelectedBatchRun.Optimizer is HeuristicLab.Optimization.IAlgorithm)
+
+        @if (Model.SelectedBatchRun.Optimizer is HeuristicLab.Optimization.IAlgorithm)
             {
-                @Html.Partial("OpenFilePartials/_AlgorithmSmall",
+            @Html.Partial("OpenFilePartials/_AlgorithmSmall",
                 new HeuristicLab.Clients.Hive.WebJobManager.Models.AlgorithmContainer(
                     ((HeuristicLab.Optimization.IAlgorithm)Model.SelectedBatchRun.Optimizer),
                     new List<int[]>(),
-                    new int[] { 0, k },
+                    new int[] { 0, 0 },
                     randomizer));
 
@@ -59,9 +58,9 @@
             else if (Model.SelectedBatchRun.Optimizer is HeuristicLab.Optimization.BatchRun)
             {
-                @Html.Partial("OpenFilePartials/_BatchRunSmall",
+            @Html.Partial("OpenFilePartials/_BatchRunSmall",
                 new HeuristicLab.Clients.Hive.WebJobManager.Models.BatchRunContainer(
                     ((HeuristicLab.Optimization.BatchRun)Model.SelectedBatchRun.Optimizer),
                     new List<int[]>(),
-                    new int[] { 0, k },
+                    new int[] { 0, 0 },
                     randomizer));
 
@@ -69,13 +68,13 @@
             else if (Model.SelectedBatchRun.Optimizer is HeuristicLab.Optimization.Experiment)
             {
-                @Html.Partial("OpenFilePartials/_ExperimentSmall",
+            @Html.Partial("OpenFilePartials/_ExperimentSmall",
                 new HeuristicLab.Clients.Hive.WebJobManager.Models.ExperimentContainer(
                     ((HeuristicLab.Optimization.Experiment)Model.SelectedBatchRun.Optimizer),
                     new List<int[]>(),
-                    new int[] { 0, k },
+                    new int[] { 0, 0 },
                     randomizer));
 
             }
-        }
+
     </div>
 </div>
Index: /branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Views/Job/OpenFilePartials/_BatchRunSmall.cshtml
===================================================================
--- /branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Views/Job/OpenFilePartials/_BatchRunSmall.cshtml	(revision 13843)
+++ /branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Views/Job/OpenFilePartials/_BatchRunSmall.cshtml	(revision 13844)
@@ -18,5 +18,5 @@
        aria-expanded="false"
        aria-controls="collapseExample@(randombr)"
-        style="margin:10px;margin-bottom:0; box-shadow: 0 4px 8px 0 rgba(0, 0, 0, 0.2), 0 6px 20px 0 rgba(0, 0, 0, 0.19);
+       style="margin:10px;margin-bottom:0; box-shadow: 0 4px 8px 0 rgba(0, 0, 0, 0.2), 0 6px 20px 0 rgba(0, 0, 0, 0.19);
                             text-shadow:2px 2px black;">
         @Model.batch.Name
@@ -24,13 +24,11 @@
 
 </p>
-<div class="collapse" 
-     id="collapseExample@(randombr)" 
-     style="margin-left:10px;margin-right:10px;margin-top:-10px "
-     
-     >
-    <img src="~/img/accoladebatch.png" 
+<div class="collapse"
+     id="collapseExample@(randombr)"
+     style="margin-left:10px;margin-right:10px;margin-top:-10px ">
+    <img src="~/img/accoladebatch.png"
          style="width:100%" />
 
-    <div class="panel panel-warning" 
+    <div class="panel panel-warning"
          style="border-color:#f6cd94!important; border-width:2px!important;
             box-shadow: 0 4px 8px 0 rgba(0, 0, 0, 0.2), 0 6px 20px 0 rgba(0, 0, 0, 0.19);
@@ -57,13 +55,13 @@
 
                 Distribute child tasks
-                <input type="checkbox" 
-                       checked 
-                       data-toggle="toggle" 
+                <input type="checkbox"
+                       checked
+                       data-toggle="toggle"
                        data-onstyle="warning"
                        onchange="toggleChild(@builder, @randombr)" />
-                
+
 
             </p>
-            <div class="btn-group" 
+            <div class="btn-group"
                  style="text-shadow:none">
 
@@ -72,5 +70,5 @@
                         class="btn btn-info dropdown-toggle"
                         data-toggle="dropdown"
-                        aria-haspopup="true" 
+                        aria-haspopup="true"
                         aria-expanded="false">
                     Normal <span class="caret"></span>
@@ -85,37 +83,35 @@
         </div>
         <div id="childs@(randombr)">
-            @for (var k = 0; k < Model.batch.Repetitions; k++)
+            @if (Model.batch.Optimizer is HeuristicLab.Optimization.IAlgorithm)
             {
-                @if (Model.batch.Optimizer is HeuristicLab.Optimization.IAlgorithm)
-                {
-                    @Html.Partial("OpenFilePartials/_AlgorithmSmall",
+                @Html.Partial("OpenFilePartials/_AlgorithmSmall",
                     new HeuristicLab.Clients.Hive.WebJobManager.Models.AlgorithmContainer(
                         ((HeuristicLab.Optimization.IAlgorithm)Model.batch.Optimizer),
                         Model.depth.ToList(),
-                        new int[] { 0, k },
+                        new int[] { 0, 0 },
                         Model.randy))
 
-                }
-                else if (Model.batch.Optimizer is HeuristicLab.Optimization.BatchRun)
-                {
-                    @Html.Partial("OpenFilePartials/_BatchRunSmall",
+            }
+            else if (Model.batch.Optimizer is HeuristicLab.Optimization.BatchRun)
+            {
+                @Html.Partial("OpenFilePartials/_BatchRunSmall",
                     new HeuristicLab.Clients.Hive.WebJobManager.Models.BatchRunContainer(
                         ((HeuristicLab.Optimization.BatchRun)Model.batch.Optimizer),
                         Model.depth.ToList(),
-                        new int[] { 0, k },
+                        new int[] { 0, 0 },
                         Model.randy)) ;
 
-                }
-                else if (Model.batch.Optimizer is HeuristicLab.Optimization.Experiment)
-                {
-                    @Html.Partial("OpenFilePartials/_ExperimentSmall",
+            }
+            else if (Model.batch.Optimizer is HeuristicLab.Optimization.Experiment)
+            {
+                @Html.Partial("OpenFilePartials/_ExperimentSmall",
                     new HeuristicLab.Clients.Hive.WebJobManager.Models.ExperimentContainer(
                         ((HeuristicLab.Optimization.Experiment)Model.batch.Optimizer),
                         Model.depth.ToList(),
-                        new int[] { 0, k },
+                        new int[] { 0, 0 },
                         Model.randy)) ;
 
-                }
             }
+
         </div>
     </div>
Index: /branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/wwwroot/js/hubs/progresshubber.js
===================================================================
--- /branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/wwwroot/js/hubs/progresshubber.js	(revision 13843)
+++ /branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/wwwroot/js/hubs/progresshubber.js	(revision 13844)
@@ -1,1 +1,1 @@
-function addtoHive(){var a=document.getElementById("jname").value,b=document.getElementById("jresource").value;a&&""!=a&&null!=a?(hubber.server.changeNameResource(a,b),document.getElementById("fakehiveadd").style.display="none",document.getElementById("progdiv").style.display="",document.getElementById("result").style.display="",document.getElementById("realhiveadd").click()):alert("Job name not set!")}function toggleChild(a,b){console.log(a+" toggled"),hubber.server.toggleChild(a),"none"==$("#childs"+b).css("display")?$("#childs"+b).css("display",""):$("#childs"+b).css("display","none"),$("body").click()}function changePriority(a,b,c){switch(hubber.server.changePriority(a,b),resetPrior(c),b){case 0:document.getElementById("prior"+c).className+="btn-default",document.getElementById("prior"+c).innerHTML="Low";break;case 1:document.getElementById("prior"+c).className+="btn-info",document.getElementById("prior"+c).innerHTML="Normal";break;case 2:document.getElementById("prior"+c).className+="btn-warning",document.getElementById("prior"+c).innerHTML="Urgent";break;case 3:document.getElementById("prior"+c).className+="btn-danger",document.getElementById("prior"+c).innerHTML="Critical"}document.getElementById("prior"+c).innerHTML+="<span class='caret'></span>"}function resetPrior(a){document.getElementById("prior"+a).className="btn dropdown-toggle "}function changeName(a,b,c){hubber.server.changeName(a,b,c)}function changeRepit(a,b){hubber.server.changeRepit(a,b)}function paraEdit(a,b,c,d,e){hubber.server.paraEdit(a,b,c,d,e)}var hubber=$.connection.progressHub;$(function(){var a=document.getElementById("userId").innerHTML;console.log(a),$.connection.hub.qs={userid:a},$.connection.hub.start().done(function(){$("#progress").css("width","0%"),$("#progress").attr("aria-valuenow",0),hubber.server.handleMessage("Looking for connection...")}),hubber.client.processMessage=function(a,b){b>$("#progress").attr("aria-valuenow")&&($("#progress").css("width",b+"%"),$("#progress").attr("aria-valuenow",b),$("#progress").html(b+"%"),$("#result").html(a))},hubber.client.processName=function(a,b){$("#nameCarrier"+b).html(a)},hubber.client.processRepit=function(a,b){"failed"===a?window.alert("Something went wrong while changing the repititions, please try again"):window.alert("Repititions for "+a+" has been changed to "+b+". These changes are not shown in the interface but happen directly after uploading or saving.")},hubber.client.dataNotSupported=function(a){window.alert("Parameter "+a+" could not be changed for it is a fixed parameter. All changes done in this view are not saved to Hive.")},hubber.client.formatWrong=function(a,b){window.alert("Parameter "+a+" could not be changed, the format for "+b+" was wrong. Make sure you follow the example exactly. No changes made on Hive")}});
+function addtoHive(){var a=document.getElementById("jname").value,b=document.getElementById("jresource").value;a&&""!=a&&null!=a?(hubber.server.changeNameResource(a,b),document.getElementById("fakehiveadd").style.display="none",document.getElementById("progdiv").style.display="",document.getElementById("result").style.display="",document.getElementById("realhiveadd").click()):alert("Job name not set!")}function toggleChild(a,b){console.log(a+" toggled"),hubber.server.toggleChild(a),"none"==$("#childs"+b).css("display")?$("#childs"+b).css("display",""):$("#childs"+b).css("display","none"),$("body").click()}function changePriority(a,b,c){switch(hubber.server.changePriority(a,b),resetPrior(c),b){case 0:document.getElementById("prior"+c).className+="btn-default",document.getElementById("prior"+c).innerHTML="Low";break;case 1:document.getElementById("prior"+c).className+="btn-info",document.getElementById("prior"+c).innerHTML="Normal";break;case 2:document.getElementById("prior"+c).className+="btn-warning",document.getElementById("prior"+c).innerHTML="Urgent";break;case 3:document.getElementById("prior"+c).className+="btn-danger",document.getElementById("prior"+c).innerHTML="Critical"}document.getElementById("prior"+c).innerHTML+="<span class='caret'></span>"}function resetPrior(a){document.getElementById("prior"+a).className="btn dropdown-toggle "}function changeName(a,b,c){hubber.server.changeName(a,b,c)}function changeRepit(a,b){hubber.server.changeRepit(a,b)}function paraEdit(a,b,c,d,e){hubber.server.paraEdit(a,b,c,d,e)}var hubber=$.connection.progressHub;$(function(){$("#success-alert").hide();var a=document.getElementById("userId").innerHTML;console.log(a),$.connection.hub.qs={userid:a},$.connection.hub.start().done(function(){$("#progress").css("width","0%"),$("#progress").attr("aria-valuenow",0),hubber.server.handleMessage("Looking for connection...")}),hubber.client.processMessage=function(a,b){b>$("#progress").attr("aria-valuenow")&&($("#progress").css("width",b+"%"),$("#progress").attr("aria-valuenow",b),$("#progress").html(b+"%"),$("#result").html(a))},hubber.client.processName=function(a,b){$("#nameCarrier"+b).html(a)},hubber.client.saveComplete=function(a){$("#succText").html(a),$("#success-alert").alert(),$("#success-alert").fadeTo(2e3,500).slideUp(500,function(){$("#success-alert").hide()})},hubber.client.createAlert=function(a,b){$("#logs").html("<div class='alert alert-"+b+" alert-dismissible fade in' role='alert'> <button type='button' class='close' data-dismiss='alert' aria-label='Close'> <span aria-hidden='true'>&times;</span> </button> "+a+"</div>"+$("#logs").html())},hubber.client.formatWrong=function(a,b){addAlert("Format wrong for "+a+" of type "+b+". Make sure you follow the right format pattern.","warning")}});